"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var inject_universe_1 = require("./inject-universe");
var utils_1 = require("./utils");
var visitPossibleActionOrComponent = function (t, name, rootPath, params, bodyPath, async) {
    if (utils_1.isPossibleComponentName(name)) {
        inject_universe_1.default(t, "component", name, rootPath, params, bodyPath, async);
    }
    else if (utils_1.isPossibleActionName(name)) {
        inject_universe_1.default(t, "action", name, rootPath, params, bodyPath, async);
    }
};
exports.default = (function (_a) {
    var t = _a.types;
    return ({
        FunctionDeclaration: function (path) {
            if (path.node.id == null) {
                return;
            }
            var name = path.node.id.name;
            var bodyPath = path.get("body");
            visitPossibleActionOrComponent(t, name, path, path.node.params, bodyPath, path.node.async);
        },
        VariableDeclaration: function (path) {
            if (path.node.declarations.length !== 1) {
                // Not yet supported
                return;
            }
            var declarationPath = path.get("declarations")[0];
            if (!(t.isArrowFunctionExpression(declarationPath.node.init) ||
                t.isFunctionExpression(declarationPath.node.init))) {
                // Not a function.
                return;
            }
            if (!t.isIdentifier(declarationPath.node.id)) {
                // Not yet supported.
                return;
            }
            var name = declarationPath.node.id.name;
            var bodyPath = declarationPath.get("init").get("body");
            visitPossibleActionOrComponent(t, name, path, declarationPath.node.init.params, bodyPath, declarationPath.node.init.async);
        },
    });
});
//# sourceMappingURL=components-and-actions.js.map